<!---
You must have OpenOffice installed on your ColdFusion server for certain parts of this application to run.
Please see http://help.adobe.com/en_US/ColdFusion/9.0/Installing/WS899EE911-747B-45cf-8550-DC9123823364.html
--->

<cfsetting requesttimeout="3000">

<!---Set up--->
<cfset Variables.thisDir = replace(getDirectoryFromPath(GetCurrentTemplatePath()), "\", "/", "all")>
<cfset Variables.presoSubDir = "presentations">
<cfset Variables.pptSubDir = Variables.presoSubDir & "/" & urlEncodedFormat("ppt") & "/">
<cfset Variables.thumbSubDir = Variables.presoSubDir & "/" & urlEncodedFormat("thumb") & "/">
<cfset Variables.htmlSubDir = Variables.presoSubDir & "/" & urlEncodedFormat("html") & "/">
<cfset Variables.connectSubDir = Variables.presoSubDir & "/" & urlEncodedFormat("connect") & "/">
<cfset Variables.pdfSubDir = Variables.presoSubDir & "/" & urlEncodedFormat("pdf") & "/">
<cfset Variables.pptDir = Variables.thisDir & Variables.pptSubDir>
<cfset Variables.thumbDir = Variables.thisDir & Variables.thumbSubDir>
<cfset Variables.htmlDir = Variables.thisDir & Variables.htmlSubDir>
<cfset Variables.connectDir = Variables.thisDir & Variables.connectSubDir>
<cfset Variables.pdfDir = Variables.thisDir & Variables.pdfSubDir>

<cfif isDefined("Form.pptSubmitButton") OR isDefined("Form.urlSubmitButton")>
	<!---Create directory for PPT files--->
	<cfif NOT directoryExists(Variables.pptDir)>
		<cfdirectory action="create" directory="#Variables.pptDir#">
	</cfif>
	
	<!---Option 1:  upload the PPT file--->
	<cfif isDefined("Form.pptFile")>
		<!---Handle uploaded presentations here--->
		<!---Upload file--->
		<cffile action="upload" fileField="Form.pptFile" destination="#Variables.pptDir#" nameConflict="overwrite" accept="application/vnd.ms-powerpoint,application/octet-stream">
		<cfset Variables.fileName = cffile.ClientFileName>
	</cfif>
	
	<!---Option 2:  create the PPT file from HTML from a URL--->
	<cfif isDefined("Form.txtURL")>
		<!---Get the HTML from the supplied URL--->
		<cfhttp url="#Form.txtURL#" />
		<cfset Variables.fileName = Mid(cfhttp.fileContent, Find("<title>", cfhttp.fileContent) + 7, Find("</title>", cfhttp.fileContent) - Find("<title>", cfhttp.fileContent) - 7)>
		
		<!---Create PPT version of the HTML file--->
		<cfpresentation format="ppt" title="#Variables.fileName#" destination="#Variables.pptDir##Variables.fileName#.ppt" overwrite="true">
			<cfpresentationslide title="#Variables.fileName#">
				<cfoutput>#cfhttp.fileContent#</cfoutput>
			</cfpresentationslide>
		</cfpresentation>
	</cfif>
	
	<cfif isDefined("Form.txtURL") OR isDefined("Form.pptFile")>
		<!---Do conversions here--->
		<!---Create directory for HTML version of PPT file--->
		<cfif NOT directoryExists(Variables.htmlDir & Variables.fileName)>
			<cfdirectory action="create" directory="#Variables.htmlDir##Variables.fileName#">
		</cfif>
		
		<!---Create HTML version of PPT file--->
		<cfpresentation title="#Variables.fileName#" format="html" directory="#Variables.htmlDir##Variables.fileName#" overwrite="true">
			<cfpresentationslide src="#Variables.pptDir##Variables.fileName#.ppt" />
		</cfpresentation>
		
		<!---Create directory for Connect version of PPT file--->
		<cfif NOT directoryExists(Variables.connectDir & Variables.fileName)>
			<cfdirectory action="create" directory="#Variables.connectDir##Variables.fileName#">
		</cfif>
		
		<!---Create Connect version of PPT file--->
		<cfpresentation title="#Variables.fileName#" directory="#Variables.connectDir##Variables.fileName#" overwrite="true">
			<cfpresentationslide src="#Variables.pptDir##Variables.fileName#.ppt" />
		</cfpresentation>
		
		<!---Create PDF version of PPT file--->
		<cfdocument format="pdf" filename="#Variables.pdfDir##Variables.fileName#.pdf" srcfile="#Variables.pptDir##Variables.fileName#.ppt" overwrite="true" />
		
		<!---Create thumbnail version of PDF file--->
		<cfpdf action="thumbnail" source="#Variables.pdfDir##Variables.fileName#.pdf" destination="#Variables.thumbDir#" scale="20" overwrite="true" pages="1">
		
		<!---Redirect back to this page as a GET instead of a POST--->
		<cflocation url="#urlEncodedFormat(GetFileFromPath(CGI.Script_Name))#" addtoken="no">
	</cfif>
<cfelseif isDefined("Form.pdfPackageSubmitButton")>
	<!---Create custom PDF package here--->
	<cfpdf action="merge" destination="myPresoPortfolio.pdf" overwrite="yes" package="true">
		<cfloop index="Variables.listItem" list="#Form.fieldNames#">
			<cfif Variables.listItem NEQ "pdfPackageSubmitButton">
				<cfif Left(Variables.listItem, 3) EQ "ppt">
					<cfset Variables.subDir = Variables.pptSubDir>
					<cfset Variables.fileExt = ".ppt">
				<cfelseif Left(Variables.listItem, 3) EQ "pdf">
					<cfset Variables.subDir = Variables.pdfSubDir>
					<cfset Variables.fileExt = ".pdf">
				</cfif>
				
				<cfpdfparam source="#Variables.subDir & urlDecode(Right(Variables.listItem, Len(Variables.listItem) - 3)) & Variables.fileExt#">
			</cfif>
		</cfloop>
	</cfpdf>
	
	<cfcontent file="#ExpandPath('myPresoPortfolio.pdf')#" type="application/pdf" deletefile="yes">
</cfif>

<!---Get a list of all presentations for output--->
<cfdirectory action="list" directory="#Variables.htmlDir#" name="Variables.presentationsQuery" type="dir">

<html>
	<head>
		<title>Presentastic</title>
	</head>
	<body>
		<!---Display goes here--->
		<h2>Welcome to Presentastic!</h2>
		
		<!---Option 1:  upload the PPT file--->
		<form name="pptForm" action="<cfoutput>#GetFileFromPath(CGI.Script_Name)#</cfoutput>" method="post" enctype="multipart/form-data">
			Upload a presentation:
			<input type="file" name="pptFile">
			<input type="submit" name="pptSubmitButton" value="Submit">
		</form>
		
		<!---Option 2:  create the PPT file from HTML from a URL--->
		<form name="htmlForm" action="<cfoutput>#GetFileFromPath(CGI.Script_Name)#</cfoutput>" method="post" enctype="multipart/form-data">
			Specify a URL:
			<input type="text" name="txtURL">
			<input type="submit" name="urlSubmitButton" value="Submit">
		</form>
		
		<form name="pdfPackageForm" action="<cfoutput>#GetFileFromPath(CGI.Script_Name)#</cfoutput>" method="post" enctype="multipart/form-data">
			<table>
				<tr>
					<cfoutput query="Variables.presentationsQuery">
						<cfif NOT (Variables.presentationsQuery.CurrentRow - 1) MOD 4>
							</tr>
							<tr>
						</cfif>
						
						<td>
							<table>
								<tr>
									<td align="center">
										#Variables.presentationsQuery.Name#
										<br>
										<img src="#Variables.thumbSubDir##urlEncodedFormat(Variables.presentationsQuery.Name)#_Page_1.jpg" border="1">
									</td>
								</tr>
								<tr>
									<td align="center">
										<a href="#Variables.htmlSubDir##urlEncodedFormat(Variables.presentationsQuery.Name)#/index.html">HTML</a> |
										<a href="#Variables.connectSubDir##urlEncodedFormat(Variables.presentationsQuery.Name)#/index.htm">Connect</a>
									</td>
								</tr>
								<tr>
									<td align="center">
										<input name="pdf#urlEncodedFormat(Variables.presentationsQuery.Name)#" type="checkbox" value="1">
										<a href="#Variables.pdfSubDir##urlEncodedFormat(Variables.presentationsQuery.Name)#.pdf">PDF</a> |
										<input name="ppt#urlEncodedFormat(Variables.presentationsQuery.Name)#" type="checkbox" value="1">
										<a href="#Variables.pptSubDir##urlEncodedFormat(Variables.presentationsQuery.Name)#.ppt">PowerPoint</a>
									</td>
								</tr>
							</table>
						</td>
					</cfoutput>
				</tr>
				<tr>
					<td colspan="4" align="center"><input name="pdfPackageSubmitButton" type="submit" value="Create PDF Package"></td>
				</tr>
			</table>
		</form>
	</body>
</html>